﻿using System.Linq;
using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class ExecExpandExpression : Expression
    {
        public ExecExpandExpression(Expression[] expressions) : base(OpCode.ExecExpand)
        {
            this.Expressions = expressions;
        }

        public Expression[] Expressions { get; }

        public override void Eval(IInterpreterService interpreterService)
        {
            foreach (var expression in this.Expressions)
            {
                interpreterService.ExecStack.Add(expression);
            }
        }

        public override string ToString()
        {
            return $"({string.Join(", ", this.Expressions.Reverse())})";
        }
    }
}
