﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class IntegerPushExpression : Expression
    {
        public IntegerPushExpression(long value) : base(OpCode.IntegerPush)
        {
            this.Value = value;
        }

        public long Value { get; }

        public override void Eval(IInterpreterService interpreterService)
        {
            interpreterService.IntegerStack.Push(Value);
        }

        public override string ToString()
        {
            return $"{base.ToString()}({this.Value})";
        }
    }
}
